Previous: [[Usage]] | Next: [[Flash Message Component]]

------

This addon is built to be very extendible. You can change, add, and overwrite functionality using the [method described in this post](http://discuss.emberjs.com/t/extending-models-from-a-ember-addon/6881). However, some features are customizable out of the box.

With regards to the `{{message-queue}}` component, you can easily customize:
- [Message interval](#message-interval)
- [Class name](#class-name)
- [Template](#template)


## Message Interval

To change the default interval of the queue (the time each timed message is shown for), you can set the option on the component:

```hbs
{{!-- app/templates/application.hbs --}}

{{message-queue interval=5000}}
```

> Warning: you must set the interval option in the template, not component module, to ensure correct binding with the message queue. This is a known issue.

When you pass a duration to a message using `flashMessage` the duration will override the interval.


## Class Name

You can customize the base class name of the queue component by extending the `message-queue` component in your app's tree:

```js
// app/components/message-queue.js

import MessageQueueComponent from 'ember-flash-messages/components/message-queue';

export default MessageQueueComponent.extend({
  className: 'queue' // String
});
```


## Template

You can easily change the message queue's template by overwriting `app-name/templates/components/message-queue.hbs`:

```hbs
{{!-- app/templates/components/message-queue.hbs --}}

Your custom Handlebars here.
```

You can reference the [original template file here](https://github.com/sir-dunxalot/ember-flash-messages/blob/master/app/templates/components/message-queue.hbs)

------

Previous: [[Usage]] | Next: [[Flash Message Component]]
