Previous: [[Flash Message Component]]

------

## Contents
- [Introduction](#introduction)
- [Styling the queue](#the-queue)
- [Styling messages](#messages)


## Introduction

Currently, styling is left up to you. Class names follow a [BEM-like syntax](http://www.smashingmagazine.com/2012/04/16/a-new-front-end-methodology-bem/).

The general format for classes is:

```scss
.className-modifier // Modifier is based on the current message type
```

**This addon comes prepackaged with styling for the layout of messages**. To include the small layout stylesheet in your application, simply set the relevant option in your Brocfile:

```js
var app = new EmberApp({

  flashMessages: {
    layout: true // Automatically adds CSS to your app
  }

});
```


## The queue

By default, the message queue will have the following class:

```scss
.flash_queue
```

You can change this as described in [[the flash message component docs|Flash Message Component]].


## Messages

By default, each message is a definition list (`<dl>`) containing the message type (`<dt>`) and message content (`<dd>`). You can checkout the [message template here](https://github.com/sir-dunxalot/ember-flash-messages/blob/master/app/templates/components/flash-message.hbs) but this is the rough structure once a message is rendered in the DOM:

```hbs
<dl {{bind-attr class='messageClass'}}>

  <dt class="icon_wrapper">
    <span {{bind-attr class='iconClass'}}></span>

    <span class="hidden">
      {{type}}
    </span>
  </dt>

  <dd class="content">
    {{{content}}}{{!-- Allow HTML --}}
    {{yield}}{{!-- Allow block helpers --}}
  </dd>

  {{#unless message.timed}}
    <div class="button_wrapper">
      <button class="button">
        <span class="icon-close"></span>
        <span class="hidden">Close</span>
      </button>
    </div>
  {{/unless}}

</dl>
```

You can view the `{{message-queue}}` [template here](https://github.com/sir-dunxalot/ember-flash-messages/blob/master/app/templates/components/message-queue.hbs).

By default, each message will have the following class structure:

```scss
.flash_message-type
```

When you push a message to the queue, the class will be modified with the message type. For example:

```scss
// this.flashMessage('success', 'Congratulations!');
.flash_message-success

//this.flashMessage('error', 'Uh oh!');
.flash_message-error
```

------

Previous: [[Flash Message Component]]
